<?

/*
	Show sudoku's from database as PDF

        (C) Copyright 2005 by Mogens Kjaer, mk@lemo.dk

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

include('utilities.php');

function errormessage($dan, $eng)
{
  global $lang;
  echo "<HTML>\n";
  echo "<HEAD>\n";
  echo "  <META HTTP-EQUIV=\"content-type\" CONTENT=\"TEXT/HTML; CHARSET=ISO-8859-1\">\n";
  echo "  <META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
  if($lang==0)
    echo "  <TITLE>Sudoku opgavest</TITLE>\n";
  else
    echo "  <TITLE>Sudoku puzzles</TITLE>\n";
  echo "</HEAD>\n";
  echo "<body>\n";

  if($lang==0)
  {
    echo "<h1>Fejl!</h1>\n";
    echo "<p>".$dan."</p>\n";
    echo "Klik <A HREF=\"javascript:history.back(-1)\">tilbage</a> og ret fejlen.</p>\n";
  }
  else
  {
    echo "<h1>Error!</h1>\n";
    echo "<p>".$eng."</p>\n";
    echo "Click <A HREF=\"javascript:history.back(-1)\">back</a> and correct the error.</p>\n";
  }
  echo "</body>\n";
  echo "</html>\n";
  exit;
}

function show_sudoku($xmin, $xmax, $ymin, $ymax, $nx, $ny, $serial, $problem, $solution, $showsolution, $showpossibilities, $txt, $solpage)
{
  global $SYMBOLLIST, $lang;
  $p = "";
  $nxny = $nx*$ny;

  if(($xmax-$xmin)>($ymax-$ymin))
  {
    $size = $ymax-$ymin;
  }
  else
  {
    $size = $xmax-$xmin;
  }
  $size = $size*0.9;
  $p .= "gsave ".(($xmax-$xmin)/2-$size/2+$xmin)." ".(($ymax-$ymin)/2-$size/2+$ymin)." translate\n";
  $cellsize = $size/$nxny;
  $fontsize = $cellsize*0.9;
  $hintfontsize = $fontsize/max($nx,$ny);
  $headlinefontsize = $size/25;
  $subtextfontsize = $size/35;
  $thinwidth = $cellsize/40;
  $thickwidth = $thinwidth*3;
  $p .= "/Helvetica-ISOLatin1 findfont ".$headlinefontsize." scalefont setfont\n";
  $p .= ($size/2)." ".($size+1*$headlinefontsize)." moveto (Sudoku ";
  if($lang==0)
    $p .= "nr";
  else
    $p .= "no";
  $p .= ". ".$serial.") show4\n";

  $p .= "/Helvetica-ISOLatin1 findfont ".$fontsize." scalefont setfont\n";
  $y = $size;
  $i=0;
  if($showsolution)
    $probsol = $solution;
  else
    $probsol = $problem;

  for($row=0; $row<$nxny; $row++)
  {
    if($row>0)
    {
      $p .= "0 0 0 setrgbcolor\n";
      $width = ($row%$ny==0)?$thickwidth:$thinwidth;
      $p .= ($width)." setlinewidth\n";
      $p .= "newpath\n";
      $p .= $y." 0 moveto\n";
      $p .= $y." ".$size." lineto\n";
      $p .= "stroke\n";
      $width = ($row%$nx==0)?$thickwidth:$thinwidth;
      $p .= ($width)." setlinewidth\n";
      $p .= "newpath\n";
      $p .= "0 ".$y." moveto\n";
      $p .= $size." ".$y." lineto\n";
      $p .= "stroke\n";
    }
    $x=0;
    for($col=0; $col<$nxny; $col++)
    {
      $c = substr($probsol, $i, 1);
      if($c!="0")
      {
	$p .= (substr($problem, $i, 1)=="0"?"1":"0")." 0 0 setrgbcolor\n";
	$p .= ($x+$cellsize/2)." ".($y-$cellsize/2)." moveto\n";
	$p .= "(".$c.") show5\n";
      }
      else if($showpossibilities)
      {
	$p .= "/Helvetica-ISOLatin1 findfont ".$hintfontsize." scalefont setfont\n";
	find_possibilities($nx, $ny, $row, $col, $problem, $possibilities);
	for($i1=0;$i1<$nx;$i1++)
	for($j1=0;$j1<$ny;$j1++)
	{
	  $value = $i1*$ny+$j1+1;
	  if($possibilities[$value])
	  {
	    $p .= ($x+$cellsize/$ny*($j1+0.5))." ".($y-$cellsize/$nx*($i1+0.5))." moveto\n";
	    $p .= "(".substr($SYMBOLLIST,$value,1).") show5\n";
	  }
	}
	$p .= "/Helvetica-ISOLatin1 findfont ".$fontsize." scalefont setfont\n";
      }
      $i++;
      $x += $cellsize;
    }
    $y -= $cellsize;
  }
  $p .= $thickwidth." setlinewidth\n";
  $p .= "0 0 0 setrgbcolor\n";
  $p .= "newpath\n";
  $p .= "0 0 moveto\n";
  $p .= "0 ".$size." lineto\n";
  $p .= $size." ".$size." lineto\n";
  $p .= $size." 0 lineto\n";
  $p .= "closepath\n";
  $p .= "stroke\n";
  if(!$showsolution)
  {
    $p .= "/Helvetica-ISOLatin1 findfont ".$subtextfontsize." scalefont setfont\n";
    $y = -3*$subtextfontsize;
    if($txt != "")
    {
      $p .= ($size/2)." ".$y." moveto (".$txt.") show4\n";
      $y -= 1.5*$subtextfontsize;
    }
    if($solpage>0)
    {
      $p .= ($size/2)." ".$y." moveto (";
      if($lang==0)
	$p .= "Lsning side ";
      else
	$p .= "Solution on page ";
      $p .= $solpage.") show4\n";
      $y -= 1.5*$subtextfontsize;
    }
  }

  $p .= "grestore\n";
  return $p;
}

sudoku_db();

$maxnumber=100;
$solnx=2;
$solny=3;

if(isset($action) || isset($serial))
{
  /*
  	Generate the following arrays:

	$serials	Serial number of all problems
	$pages		Indexed as $serials: Page number on which the problem is printed
	$problems
	$solutions
	$nxs
	$nys
	$texts
	$solpages	Page no of solution
	$cattext	Category text
	$catfirst	Index into $serials of first

  */
  if(isset($serial))
  {
    $res1 = mysql_query("select * from sudoku where serial=".$serial);
    if($row1=mysql_fetch_assoc($res1))
    {
      $nxs[] = $row1["nx"];
      $nys[] = $row1["ny"];
      if($lang==0)
	$texts[] = "Kategori: ".level_text($row1["level"]).", Symmetri: ".symmetrical_text($row1["symmetrical"]);
      else
	$texts[] = "Category: ".level_text($row1["level"]).", Symmetry: ".symmetrical_text($row1["symmetrical"]);
      $res2 = mysql_query("select * from problems where serial=".$row1["serial"]);
      if($row2 = mysql_fetch_assoc($res2)) $problems[] = $row2["problem"];
      $res2 = mysql_query("select * from solutions where serial=".$row1["serial"]);
      if($row2 = mysql_fetch_assoc($res2)) $solutions[] = $row2["solution"];
      $res2 = mysql_query("update sudoku set lastused=now() where serial=".$row1["serial"]);
    }
    else
    {
      errormessage("Opgave ".$serial." findes ikke.",
                   "Puzzle ".$serial." does not exist.");
    }
    $serials[] = $serial;
    $solpages[] = 0;
    $pageno = 1;
    $ntotal = 1;
  }
  else
  {
    $ntotal=0;
    $inputntotal=0;
    $pageno=2;
    $serials=array();
    if(isset($number))
    {
      while(list($nx,$nylist)=each($number))
      {
	while(list($ny,$levels)=each($nylist))
	{
	  while(list($level,$n)=each($levels))
	  {
	    if($n>0)
	    {
	      $inputntotal += $n;
	      if(($n+$ntotal)>$maxnumber) $n=$maxnumber-$ntotal;
	      if($n>0)
	      {
		$res1 = mysql_query($q="select * from sudoku where ".
			"nx=".intval($nx)." and ".
			"ny=".intval($ny)." and ".
			"level=".intval($level)." and ".
			"(1=0".
			(isset($symmetrical[0])?" or symmetrical=0":"").
			(isset($symmetrical[1])?" or symmetrical=1":"").
			(isset($symmetrical[2])?" or symmetrical=2":"").
			") order by lastused".(isset($fewfilled)?",ndigits":"")." limit ".intval($n));
		$n = mysql_num_rows($res1);
		if($n>0)
		{
		  $cattext[] = $nx."x".$ny." ".level_text($level);
		  $catfirst[] = count($serials);
		  while($row1=mysql_fetch_assoc($res1))
		  {
		    $serials[] = $row1["serial"];
		    $nxs[] = $row1["nx"];
		    $nys[] = $row1["ny"];
		    if($lang==0)
		      $texts[] = "Kategori: ".level_text($level).", Symmetri: ".symmetrical_text($row1["symmetrical"]);
		    else
		      $texts[] = "Category: ".level_text($level).", Symmetry: ".symmetrical_text($row1["symmetrical"]);
		    $res2 = mysql_query("select * from problems where serial=".$row1["serial"]);
		    if($row2 = mysql_fetch_assoc($res2)) $problems[] = $row2["problem"];
		    $res2 = mysql_query("select * from solutions where serial=".$row1["serial"]);
		    if($row2 = mysql_fetch_assoc($res2)) $solutions[] = $row2["solution"];
		    $pages[] = $pageno;
		    $pageno++;
		    $res2 = mysql_query("update sudoku set lastused=now() where serial=".$row1["serial"]);
		  }
		}
	      }
	      $ntotal += $n;
	    }
	  }
	}
      }
    }
    if($ntotal==0)
    {
      errormessage("Der er ingen opgaver at vise. ".
        ($inputntotal==0?"Du skal fylde nogle tal i felterne, inden du klikker <b>Generr</b>.":
	                 "Du har bedt om opgaver, som ikke findes i databasen."),
		   "There are no puzzles to display. ".
        ($inputntotal==0?"You need to fill in some numbers in the form before clicking <b>Generate</b>.":
	                 "You have asked for puzzles that doesn't exist in the database."));
    }
    /* Walk through all problems and calculate page number of solution */
    reset($serials);
    $i=0;
    while($serial=each($serials))
    {
      $solpages[] = $pageno;
      $i++;
      if($i>=($solnx*$solny))
      {
	$i=0;
	$pageno++;
      }
    }
    if($i==0)
    {
      $pageno--;
    }
  }
  $xmax = 595;
  $ymax = 842;
  $p = "%!PS-Adobe-2.1\n";
  $p .= "%%Creator: http://www.lemo.dk/sudoku\n";
  $p .= "%%Pages: ".$pageno."\n";
  $p .= "%%DocumentMedia: A4 ".$xmax." ".$ymax." 0 white ()\n";
  $p .= "%%BoundingBox: 0 0 ".$xmax." ".$ymax."\n";
  $p .= "%%Orientation: Portrait\n";
  $p .= "%%EndComments\n";
  $p .= "[{\n";
  $p .= "%%BeginFeature: *PageSize A4\n";
  $p .= "<</PageSize[".$xmax." ".$ymax."]/ImagingBBox null>>setpagedevice\n";
  $p .= "%%EndFeature\n";
  $p .= "} stopped cleartomark\n";
  $p .= "mark\n";
  $p .= "/ISOLatin1Encoding \n";
  $p .= "8#000 1 8#054 {StandardEncoding exch get} for \n";
  $p .= "/minus \n";
  $p .= "8#056 1 8#217 {StandardEncoding exch get} for \n";
  $p .= "/dotlessi \n";
  $p .= "8#301 1 8#317 {StandardEncoding exch get} for \n";
  $p .= "/space /exclamdown /cent /sterling /currency /yen /brokenbar /section \n";
  $p .= "/dieresis /copyright /ordfeminine /guillemotleft /logicalnot /hyphen \n";
  $p .= "/registered /macron /degree /plusminus /twosuperior /threesuperior /acute \n";
  $p .= "/mu /paragraph /periodcentered /cedilla /onesuperior /ordmasculine \n";
  $p .= "/guillemotright /onequarter /onehalf /threequarters /questiondown /Agrave \n";
  $p .= "/Aacute /Acircumflex /Atilde /Adieresis /Aring /AE /Ccedilla /Egrave /Eacute\n";
  $p .= "/Ecircumflex /Edieresis /Igrave /Iacute /Icircumflex /Idieresis /Eth /Ntilde\n";
  $p .= "/Ograve /Oacute /Ocircumflex /Otilde /Odieresis /multiply /Oslash /Ugrave \n";
  $p .= "/Uacute /Ucircumflex /Udieresis /Yacute /Thorn /germandbls /agrave /aacute \n";
  $p .= "/acircumflex /atilde /adieresis /aring /ae /ccedilla /egrave /eacute \n";
  $p .= "/ecircumflex /edieresis /igrave /iacute /icircumflex /idieresis /eth /ntilde\n";
  $p .= "/ograve /oacute /ocircumflex /otilde /odieresis /divide /oslash /ugrave \n";
  $p .= "/uacute /ucircumflex /udieresis /yacute /thorn /ydieresis \n";
  $p .= "/ISOLatin1Encoding where not {256 array astore def} if \n";
  $p .= " cleartomark \n";
  $p .= "/makeISOEncoded \n";
  $p .= "{ findfont /curfont exch def \n";
  $p .= "/newfont curfont maxlength dict def  \n";
  $p .= "/ISOLatin1 (-ISOLatin1) def\n";
  $p .= "/curfontname curfont /FontName get dup length string cvs def \n";
  $p .= "/newfontname curfontname length ISOLatin1 length add string \n";
  $p .= "dup 0 curfontname putinterval \n";
  $p .= "dup curfontname length ISOLatin1 putinterval \n";
  $p .= "def \n";
  $p .= "curfont   \n";
  $p .= "{ exch dup /FID ne  \n";
  $p .= "{ dup /Encoding eq  \n";
  $p .= "{ exch pop ISOLatin1Encoding exch }  \n";
  $p .= "if dup /FontName eq  \n";
  $p .= "{ exch pop newfontname exch }  \n";
  $p .= "if exch newfont 3 1 roll put  \n";
  $p .= "}  \n";
  $p .= "{ pop pop }  \n";
  $p .= "ifelse  \n";
  $p .= "  }  \n";
  $p .= "  forall newfontname newfont definefont \n";
  $p .= "} def \n";
  $p .= "/Times-Roman makeISOEncoded pop \n";
  $p .= "/Times-Bold makeISOEncoded pop \n";
  $p .= "/Times-Italic makeISOEncoded pop \n";
  $p .= "/Times-BoldItalic makeISOEncoded pop \n";
  $p .= "/Helvetica makeISOEncoded pop \n";
  $p .= "/Helvetica-Bold makeISOEncoded pop \n";
  $p .= "/Helvetica-Oblique makeISOEncoded pop \n";
  $p .= "/Helvetica-BoldOblique makeISOEncoded pop \n";
  $p .= "/Courier makeISOEncoded pop \n";
  $p .= "/Courier-Bold makeISOEncoded pop \n";
  $p .= "/Courier-Oblique makeISOEncoded pop \n";
  $p .= "/Courier-BoldOblique makeISOEncoded pop \n";

  $p .=  "/sbound {dup gsave 0 0 moveto true charpath \n";
  $p .=  "         flattenpath pathbbox grestore \n";
  $p .=  "       /symax exch def /sxmax exch def \n";
  $p .=  "       /symin exch def /sxmin exch def} def \n";
  /*
      anchor points:


      3--------6--------9
      |                 |
      2        5        8
      |                 |
      1--------4--------7

  */
  $p .=  "/show1 {sbound sxmin neg symin neg rmoveto show} def\n";
  $p .=  "/show2 {sbound sxmin neg symin symax sub 2 div rmoveto show} def\n";
  $p .=  "/show3 {sbound sxmin neg symax neg rmoveto show} def\n";
  $p .=  "/show4 {sbound sxmin sxmax sub 2 div sxmin sub symin neg rmoveto show} def\n";
  $p .=  "/show5 {sbound sxmin sxmax sub 2 div sxmin sub symin symax sub 2 div rmoveto show} def\n";
  $p .=  "/show6 {sbound sxmin sxmax sub 2 div sxmin sub symax neg rmoveto show} def\n";
  $p .=  "/show7 {sbound sxmax neg symin neg rmoveto show} def\n";
  $p .=  "/show8 {sbound sxmax neg symin symax sub 2 div rmoveto show} def\n";
  $p .=  "/show9 {sbound sxmax neg symax neg rmoveto show} def\n";

  if($pageno>1)
  {
    /* Create front page */

    $p .= "0 0 0 setrgbcolor\n";
    $y = $ymax*0.8;
    $p .= "/Helvetica-ISOLatin1 findfont 50 scalefont setfont\n";
    $p .= ($xmax/2)." ".$y." moveto (".$ntotal." ";
    if($lang==0)
      $p .= "Sudoku opgave".($ntotal==1?"":"r");
    else
      $p .= "Sudoku Puzzle".($ntotal==1?"":"s");
    $p .= ") show5\n";
    $y -= 72;
    $p .= "/Helvetica-ISOLatin1 findfont 10 scalefont setfont\n";
    $p .= ($xmax/2)." ".$y." moveto (http://www.lemo.dk/sudoku) show5\n";
    $y -= 72;
    $p .= "/Helvetica-ISOLatin1 findfont 10 scalefont setfont\n";
    $p .= ($xmax/2)." ".$y." moveto (";
    if($lang==0)
    {
      setlocale(LC_TIME, "da_DK");
      $p .= "Fremstillet: ".strftime("%e. %B, %Y, %R").") show5\n";
    }
    else
    {
      setlocale(LC_TIME, "en_US");
      $p .= "Created: ".strftime("%B %e, %Y, %r").") show5\n";
    }

    $y = $ymax*0.5;
    $p .= "/Helvetica-ISOLatin1 findfont 20 scalefont setfont\n";
    $p .= ($xmax/2)." ".$y." moveto (";
    if($lang==0)
      $p .= "Indholdsfortegnelse";
    else
      $p .= "Table of Contents";
    $p .= ":) show5\n";
    $y -= 60;
    $p .= "/Helvetica-ISOLatin1 findfont 10 scalefont setfont\n";
    for($i=0; $i<count($cattext); $i++)
    {
      $p .= "108 $y moveto (".$cattext[$i].") show2\n";
      $pageno = $pages[$catfirst[$i]];
      $p .= "595 108 sub $y moveto (".$pageno.") show8\n";
      $y -= 15;
    }
    $y -= 15;
    $p .= "108 $y moveto (";
    if($lang==0)
      $p .= "Lsning".($ntotal==1?"":"er");
    else
      $p .= "Solution".($ntotal==1?"":"s");
    $p .= ":) show2\n";
    $pageno = $solpages[0];
    $p .= "595 108 sub $y moveto (".$pageno.") show8\n";
    $p .= "showpage\n";
    $pageno = 2;
  }
  for($index=0; $index<count($serials); $index++)
  {
    $p .= "/Helvetica-ISOLatin1 findfont 10 scalefont setfont\n";
    if($pageno>1)
    {
      $p .= ($xmax/2)." 36 moveto (".$pageno.") show4\n";
    }
    $p .= show_sudoku(0,$xmax,0,$ymax,
                      $nxs[$index],$nys[$index],$serials[$index],
		      $problems[$index],$solutions[$index],
		      isset($solution),isset($showpossibilities),$texts[$index],$solpages[$index]);
    $p .= "showpage\n";
    $pageno++;
  }
  if($solpages[0]>0)
  {
    $i=0;
    $bottommargin = 56;
    for($index=0; $index<count($serials); $index++)
    {
      if($i==0)
      {
	$p .= "/Helvetica-ISOLatin1 findfont 10 scalefont setfont\n";
	$p .= ($xmax/2)." 36 moveto (".$pageno.") show4\n";
      }
      $xsize = $xmax/$solnx;
      $ysize = ($ymax-$bottommargin*2)/$solny;
      $xmin2 = ($i%$solnx)*$xsize;
      $xmax2 = $xmin2+$xsize;
      $ymax2 = $ymax-$ysize*(floor($i/$solnx))-$bottommargin;
      $ymin2 = $ymax2-$ysize;
      $p .= show_sudoku($xmin2,$xmax2,$ymin2,$ymax2,
			$nxs[$index],$nys[$index],$serials[$index],
			$problems[$index],$solutions[$index],
			1,0,$texts[$index],$solpages[$index]);
      $i++;
      if($i == ($solnx*$solny))
      {
	$p .= "showpage\n";
	$pageno++;
	$i=0;
      }
    }
    if($i>0)
    {
      $p .= "showpage\n";
    }
  }

  header("Content-type: application/pdf");
  $tmpfile = tempnam("/tmp","pdf");
  $fd = fopen($tmpfile, "w");
  fwrite($fd, $p);
  fclose($fd);
  passthru("/usr/bin/gs -q -dNOPAUSE -dBATCH -sPAPERSIZE=a4 -sDEVICE=pdfwrite -sOutputFile=- -c save pop -f ".$tmpfile);
  unlink($tmpfile);
}
else
{
  echo "<HTML>\n";
  echo "<HEAD>\n";
  echo "  <META HTTP-EQUIV=\"content-type\" CONTENT=\"TEXT/HTML; CHARSET=ISO-8859-1\">\n";
  if($lang==0)
    echo "  <TITLE>Sudoku opgavest</TITLE>\n";
  else
    echo "  <TITLE>Sudoku puzzles</TITLE>\n";
  echo "  <link rel=\"stylesheet\" type=\"text/css\" href=\"sudoku.css\" title=\"Default\">\n";
  echo "</HEAD>\n";
  echo "<body>\n";

  if($lang==0)
  {
    echo "<h1>Sudoku opgavest</h1>\n";

    echo "<p>Udfyld skemaet forneden med antallet af opgaver i de forskellige strrelser\n";
    echo "og svrhedsgrader, klik p <b>Generr</b>, og du fr en PDF fil med opgaverne\n";
    echo "og lsningerne, lige til at udskrive og tage med p ferie, i toget, etc.</p>\n";

    echo "<p>Der kan maksimalt vises ".$maxnumber." opgaver i hver PDF fil.</p>\n";

    echo "<p><b>NB 1:</b> Hvis databasen ikke indeholder s mange opgaver af en bestemt type, ";
    echo "bliver antallet reduceret. Hvis der vlges for mange kategorier, kan indholdsfortegnelsen ikke vises i sin helhed.</p>\n";
    
    echo "<p><b>NB 2:</b> Det kan tage tid at producere PDF filen, nogle gange flere minutter.\n";
    echo "Hav tlmodighed!</p>\n";
  }
  else
  {
    echo "<h1>Sudoku Puzzles</h1>\n";
    echo "<p>Fill in the form below with the desired number of puzzles of the requested size and difficulty,";
    echo "and click on <b>Generate</b>.</p>";
    echo "<p>A PDF file is produced with the puzzles and their solution,";
    echo "ready to print and bring on your vacation, on the train, etc.</p>\n";

    echo "<p>A maximum of ".$maxnumber." puzzles can be retrieved in each PDF file.</p>\n";

    echo "<p><b>Note 1:</b> A fewer number of puzzles might be returned, if the database contains too few puzzles of the desired type.";
    echo "If too many categories are selected, the table of contents might not fit on the page.</p>\n";

    echo "<p><b>Note 2:</b> It takes some time to produce the PDF file, sometimes several minutes.\n";
    echo "Have patience!</p>\n";

    echo "<p><b>Note 3:</b> The PDF file is created with a page size of A4. You might need to scale the page in order to fit it on letter size.</p>\n";
  }

  echo "<p><hr></p>\n";

  echo "<form method=post action=\"$PHP_SELF\">\n";
  echo "<table border=1>\n";
  echo "<tr><th colspan=6>";
  if($lang==0)
    echo "nskede symmetrier i opgaverne";
  else
    echo "Desired symmetries in the puzzles";
  echo "<tr><th colspan=5>".symmetrical_text(0)."<td align=center><input type=checkbox name=symmetrical[0]>\n";
  echo "<tr><th colspan=5>".symmetrical_text(1)."<td align=center><input type=checkbox name=symmetrical[1] checked>\n";
  echo "<tr><th colspan=5>".symmetrical_text(2)."<td align=center><input type=checkbox name=symmetrical[2]>\n";
  if($lang==0)
    echo "<tr><th rowspan=2>Strrelse<th colspan=5>Antal opgaver:<br>Svrhedsgrad\n";
  else
    echo "<tr><th rowspan=2>Size<th colspan=5>Number of puzzles:<br>Difficulty\n";
  echo "<tr>";
  for($i=0;$i<=4;$i++) echo "<th>".level_text($i);
  echo "\n";

  $res1 = mysql_query("select nx,ny,level from statistics group by nx,ny,level");

  $lastnx = 999;
  $lastny = 999;
  $lastlevel = 4;
  while($row1 = mysql_fetch_assoc($res1))
  { 
    if($lastnx != $row1["nx"] ||
       $lastny != $row1["ny"])
    {
      for($i=0;$i<(4-$lastlevel);$i++)
      {
	echo "<td>&nbsp;";
      }
      echo "<tr>";
      echo "<td align=center>".$row1["nx"]."x".$row1["ny"];
      $lastlevel = -1;
    }
    for($i=0;$i<($row1["level"]-$lastlevel-1);$i++)
    {
      echo "<td>&nbsp;";
    }
    echo "<td align=center><input name=number[".$row1["nx"]."][".$row1["ny"]."][".$row1["level"]."] size=3>\n";
    $lastnx = $row1["nx"];
    $lastny = $row1["ny"];
    $lastlevel = $row1["level"];
  }
  for($i=0;$i<(4-$lastlevel);$i++)
  {
    echo "<td>&nbsp;";
  }
  echo "<tr><th colspan=5>";
  if($lang==0)
    echo "S f fyldte celler som muligt";
  else
    echo "As few filled cells as possible";
  echo "<td align=center><input type=checkbox name=fewfilled>\n";
  echo "<tr><th colspan=5>";
  if($lang==0)
    echo "Vis mulige kandidater i hver tomme celle";
  else
    echo "Show possible candidates in each empty cell";
  echo "<td align=center><input type=checkbox name=showpossibilities>\n";
  echo "<tr><td colspan=3 align=center><input type=reset value=\"";
  if($lang==0)
    echo "Ryd felter";
  else
    echo "Clear form";
  echo "\">\n";
  echo "<td colspan=3 align=center><input type=submit name=action value=\"";
  if($lang==0)
    echo "Generr";
  else
    echo "Generate";
  echo "\">\n";
  echo "</table>\n";
  echo "</form>\n";

  echo "</body>\n";
  echo "</html>\n";
}
?>
