#!/bin/bash

# Run every morning at 2 AM

# Removes simple sudokus (level<2) that havn't been shown (lastused=0)
# and add some more

# This takes two hours on a 450 MHz Pentium II

/bin/date

/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
delete sudoku,problems,solutions,explanations from sudoku,problems,solutions,explanations
where sudoku.serial=problems.serial and sudoku.serial=solutions.serial and sudoku.serial=explanations.serial
and sudoku.nx=2 and sudoku.ny=3 and sudoku.lastused=0 and sudoku.ndigits>9 and sudoku.symmetrical=0 and sudoku.level<2;
EOF
/usr/local/bin/bsudoku 10000 2 3 0 | /usr/bin/mysql -usudoku -psudoku sudoku

/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
delete sudoku,problems,solutions,explanations from sudoku,problems,solutions,explanations
where sudoku.serial=problems.serial and sudoku.serial=solutions.serial and sudoku.serial=explanations.serial
and sudoku.nx=2 and sudoku.ny=3 and sudoku.lastused=0 and sudoku.ndigits>12 and sudoku.symmetrical=1 and sudoku.level<2;
EOF
/usr/local/bin/bsudoku 10000 2 3 1 | /usr/bin/mysql -usudoku -psudoku sudoku

/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
delete sudoku,problems,solutions,explanations from sudoku,problems,solutions,explanations
where sudoku.serial=problems.serial and sudoku.serial=solutions.serial and sudoku.serial=explanations.serial
and sudoku.nx=2 and sudoku.ny=3 and sudoku.lastused=0 and sudoku.ndigits>8 and sudoku.symmetrical=2 and sudoku.level<2;
EOF
/usr/local/bin/bsudoku 10000 2 3 2 | /usr/bin/mysql -usudoku -psudoku sudoku

/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
delete sudoku,problems,solutions,explanations from sudoku,problems,solutions,explanations
where sudoku.serial=problems.serial and sudoku.serial=solutions.serial and sudoku.serial=explanations.serial
and sudoku.nx=3 and sudoku.ny=3 and sudoku.lastused=0 and sudoku.ndigits>25 and sudoku.symmetrical=0 and sudoku.level!=2 and sudoku.level!=3;
EOF
/usr/local/bin/bsudoku 10000 3 3 0 | /usr/bin/mysql -usudoku -psudoku sudoku

/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
delete sudoku,problems,solutions,explanations from sudoku,problems,solutions,explanations
where sudoku.serial=problems.serial and sudoku.serial=solutions.serial and sudoku.serial=explanations.serial
and sudoku.nx=3 and sudoku.ny=3 and sudoku.lastused=0 and sudoku.ndigits>27 and sudoku.symmetrical=1 and sudoku.level!=2 and sudoku.level!=3;
EOF
/usr/local/bin/bsudoku 50000 3 3 1 | /usr/bin/mysql -usudoku -psudoku sudoku

/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
delete sudoku,problems,solutions,explanations from sudoku,problems,solutions,explanations
where sudoku.serial=problems.serial and sudoku.serial=solutions.serial and sudoku.serial=explanations.serial
and sudoku.nx=3 and sudoku.ny=3 and sudoku.lastused=0 and sudoku.ndigits>25 and sudoku.symmetrical=2 and sudoku.level!=2 and sudoku.level!=3;
EOF
/usr/local/bin/bsudoku 50000 3 3 2 | /usr/bin/mysql -usudoku -psudoku sudoku

# Remove duplicates 
./removeduplicates.pl

# Optimize tables
/usr/bin/mysql -usudoku -psudoku sudoku <<EOF
optimize table sudoku;
optimize table problems;
optimize table solutions;
optimize table explanations;
EOF

/bin/date

